package sun.font;

import java.awt.font.GlyphJustificationInfo;
import java.awt.Rectangle;
import java.awt.font.FontRenderContext;
import java.awt.geom.AffineTransform;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;
import java.awt.Graphics2D;

public interface TextLineComponent
{
    public static final int LEFT_TO_RIGHT = 0;
    public static final int RIGHT_TO_LEFT = 1;
    public static final int UNCHANGED = 2;
    
    public abstract CoreMetrics getCoreMetrics();
    
    public abstract void draw(Graphics2D p0, float p1, float p2);
    
    public abstract Rectangle2D getCharVisualBounds(int p0);
    
    public abstract Rectangle2D getVisualBounds();
    
    public abstract float getAdvance();
    
    public abstract Shape getOutline(float p0, float p1);
    
    public abstract int getNumCharacters();
    
    public abstract float getCharX(int p0);
    
    public abstract float getCharY(int p0);
    
    public abstract float getCharAdvance(int p0);
    
    public abstract boolean caretAtOffsetIsValid(int p0);
    
    public abstract int getLineBreakIndex(int p0, float p1);
    
    public abstract float getAdvanceBetween(int p0, int p1);
    
    public abstract Rectangle2D getLogicalBounds();
    
    public abstract Rectangle2D getItalicBounds();
    
    public abstract AffineTransform getBaselineTransform();
    
    public abstract boolean isSimple();
    
    public abstract Rectangle getPixelBounds(FontRenderContext p0, float p1, float p2);
    
    public abstract TextLineComponent getSubset(int p0, int p1, int p2);
    
    public abstract int getNumJustificationInfos();
    
    public abstract void getJustificationInfos(GlyphJustificationInfo[] p0, int p1, int p2, int p3);
    
    public abstract TextLineComponent applyJustificationDeltas(float[] p0, int p1, boolean[] p2);
}
